﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.IO;

namespace Erettsegi26_Celloveszet
{
    class Versenyző
    {
        public string Lövések { get; set; }
        public int Ssz { get; set; }
        private static int sorszámSegéd = 0;

        public Versenyző(string sor)
        {
            Lövések = sor;
            Ssz = ++sorszámSegéd;
        }

        public int loertek(string sor)
        {
            int aktpont = 20;
            int ertek = 0;
            for (int i = 0; i < sor.Length; i++)
            {
                if (aktpont > 0 && sor[i] == '-') aktpont--;
                else ertek += aktpont;
            }
            return ertek;
        }

        public int Pontszám { get { return loertek(Lövések); } }
    }

    class loves
    {
        static void Main()
        {
            Console.WriteLine("1. Feladat: veseny.txt beolvasása");
            List<Versenyző> versenyzők = new List<Versenyző>();
            foreach (var i in File.ReadAllLines("verseny.txt").Skip(1)) versenyzők.Add(new Versenyző(i));

            Console.Write("2. Feladat:\nEgymás után többször találó versenyzők: ");
            versenyzők.Where(x => x.Lövések.Contains("++")).ToList().ForEach(x => { Console.Write("{0} ", x.Ssz); });

            Console.WriteLine("\n3. Feladat:\nA legtöbb lövést leadó versenyző rajtszáma: {0}", versenyzők.OrderBy(x => x.Lövések.Length).Last().Ssz);

            Console.Write("5. feladat:\nKérek egy rajtszámot! ");
            Versenyző akt = versenyzők[int.Parse(Console.ReadLine()) - 1];

            Console.Write("5a. feladat: Célt érő lövések: ");
            for (int i = 0; i < akt.Lövések.Count(); i++) if (akt.Lövések[i] == '+') Console.Write("{0} ", i + 1);

            Console.WriteLine("\n5b. feladat: Az eltalált korongok száma: {0}", akt.Lövések.Count(x => x == '+'));

            string keres = "".PadLeft(akt.Lövések.Length, '+');
            while (keres.Length > 0)
            {
                if (akt.Lövések.IndexOf(keres) > 0) break;
                else keres = keres.Substring(0, keres.Length - 1);
            }
            Console.WriteLine("5c. feladat: A leghosszabb hibátlan sorozat hossza: {0}", keres.Length);

            Console.WriteLine("5d. feladat: A versenyző pontszáma: {0}", akt.Pontszám);

            Console.WriteLine("6. Feladat: sorrend.txt");
            var sorrend = versenyzők.OrderByDescending(x => x.Pontszám).ToList();
            int helyezés = 1;
            List<string> ki = new List<string>();
            for (int i = 0; i < sorrend.Count(); i++)
            {
                if (i != 0 && sorrend[i].Pontszám < sorrend[i - 1].Pontszám) helyezés=i+1;
                ki.Add(String.Format("{0}\t{1}\t{2}", helyezés, sorrend[i].Ssz, sorrend[i].Pontszám));
            }
            File.WriteAllLines("sorrend.txt", ki);
            Console.ReadKey();
        }
    }
}
